/*! 
\file 
\brief Sound Device

Common interface for sound devices
\date 25 November 2003
\author Evgeny Karpov
*/

/*
    $Id: sdevice.h,v 1.1 2003/11/26 14:00:58 ekarpov Exp $
*/

#ifndef __SDEVICE_H__
#define __SDEVICE_H__

/*======================== Structures =============================*/
/*======================== Structures =============================*/

typedef void * HSDEV ;

/*======================== Functions ==============================*/

/* open/close */
HSDEV sdevOpen(void * call_back) ;
void sdevClose(HSDEV sdev) ;

/* working with buffers */
/* int sdevAddBuffer(void * buffer, int size) ; */
void * sdevGetBuffer() ;
int sdevReleaseBuffer() ;

/* device manipulations */
int sdevStart(HSDEV sdev) ;
int sdevStop(HSDEV sdev) ;
int sdevPause(HSDEV sdev) ;
int sdevResume(HSDEV sdev) ;

/*======================== Functions ==============================*/

#endif /* __SDEVICE_H__ */

