/*! 
\file
\brief Comma separated values parsing 

Comma separated values parsing routines

$Id: csv.h,v 1.6 2003/11/05 22:09:09 juhani Exp $

\date 03 November 2003
\author Evgeny Karpov
*/

#ifndef __CSV_H__ 
#define __CSV_H__

/*-----------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>

#if defined(__cplusplus)
extern "C" {
#endif

/*======================== Structures =============================*/

/*! 
\brief Comma separated value structure

A data structure for storing comma separated values
*/
typedef struct {

    int count ;      /*!< number of fields */
    char ** fields ; /*!< actual fields */

} CSV ;

/*======================== Structures =============================*/

/*======================== Functions ==============================*/

/* creation/deletion */
CSV * csvCreate(int fields_num) ;
void  csvDestroy(CSV * pcsv) ;

/* reads line from string and parses it into CSV structure  */
CSV * csvParseLine(char * str_buff,int size) ;

/* writes CSV structure into a string as one line (\r also included)  */
int csvWriteLine(CSV * pcsv,char * str_buff,int size) ;

/* parses line but not allocates any memory */
int csvParseLineNoMem(CSV * pcsv,char * str_buff,int size) ;

/*======================== Functions ==============================*/

#if defined(__cplusplus)
}
#endif

#endif /* __CSV_H__ */
