/* profmatch.h by Ville Hautamki <villeh@cs.joensuu.fi>, 2002-2003
*/

#ifndef PROFMATCH_H
#define PROFMATCH_H

#include "list.h"
#include "util.h"

typedef struct Parameters Parameters;

struct Parameters {
  double f0w;
  double ltasw;
  double lfccw;
  double mfccw;
  char weights[LINEBUF];
  char unknown[LINEBUF];
  char instr[LINEBUF];
  int nbest;
  FILE *infile;
  FILE *unknownfile;
};

void free_params(Parameters *parap);
Parameters *init_params(void);
void parse_params(Parameters *parap, int argc, char **argv);
void open_files(Parameters *parap);
long setwatch(void);
void prtime(long start);
void print_usage(void);
Csv *read_all_data(FILE *infile, List *profile);

#endif
