/*!
\file melfilters.h
\brief Mel filter bank interface

Interface for mel-filterbank creation.\n
$Id: melfilters.h,v 1.4 2003/12/31 08:14:58 juhani Exp $
\todo The logarithms and square roots and all math functions
values must be scaled later after a proper analysis is done
about how they should be scaled when using INT16 or INT32;
this may also change the interface, if the scaling will
be adjustable during run time.
\date 2003
\author Evgeny Karpov
*/

#ifndef MELFILTERS_H
#define MELFILTERS_H


#include <fixmath.h>

    
#include "filterbank.h"


#if defined(__cplusplus)
extern "C" {
#endif


#define MELFILTER_SCALE 32767


/*======================== Functions ==============================*/


/* create a mel filter bank */
HFBANK * melfbCreate(
	int filters,
	int sampling_rate,
	int spectrum_size) ;


/*======================== Functions ==============================*/


#if defined(__cplusplus)
}
#endif

#endif /* MELFILTERS_H */

