#include <stdlib.h>


#include "fftsf.h"
#include "shortfft.h"


short x[FFT_N];
long qf[(FFT_N/2)+1];


extern void fft_1 ();
extern void fft_2 ();
extern void fft_3 ();
extern void fft_4 ();
extern void fft_5 ();
extern void fft_6 ();
extern void fft_7 ();
extern void fft_8 ();
extern void fft_9 ();
extern void fft_10 ();


int shortfft(
	short n,
	short* input,
	long* output,
	short* xoutput)
{
	int i;

	if (n <= 1 || n > FFT_N)
	{
		return -1;
	}
	
	for (i = 2; i < n; i <<= 1)
	{
		;
	}

	if (i != n)
	{
		return -1;
	}

	for (i = 0; i < n; i++)
	{
		x[i] = input[i];
	}

	switch (n)
	{
		case 2:
			fft_1();
			break;
		case 4:
			fft_2();
			break;
		case 8:
			fft_3();
			break;
		case 16:
			fft_4();
			break;
		case 32:
			fft_5();
			break;
		case 64:
			fft_6();
			break;
		case 128:
			fft_7();
			break;
		case 256:
			fft_8();
			break;
		case 512:
			fft_9();
			break;
		case 1024:
			fft_10();
			break;
	}

	for (i = 0; i < n/2 + 1; i++)
	{
		output[i] = qf[i];
	}

	if (NULL != xoutput)
	{
		for (i = 0; i < n; i++)
		{
			xoutput[i] = x[i];
		}
	}

	return 0;
}

