/*! 
\file 
\brief Feature set weight handling for classifier fusion

This module handles weights that are stored in configuration file. 
\todo get weights from API 
\todo weight normalization (rewrite from old code)
\date 8 December 2003
$Id: weight.c,v 1.1 2003/12/08 15:43:44 villeh Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "sprcfg.h"
#include "weight.h"

int getNumWeights(SProfiler * profiler)
{
  return profiler->fusion_params->num_weights;
}

char *getWeightTagIdx(SProfiler * profiler, int index)
{
  return profiler->fusion_params->weight_tags[index];
}

double getWeightIdx(SProfiler * profiler, int index)
{
  return profiler->fusion_params->weights[index];
}

double get_weight(SProfiler *sp, char *weight)
{
  int i;

  for (i = 0; i < getNumWeights(sp); i++) {
    if (!strcmp(getWeightTagIdx(sp,i), weight))
      return getWeightIdx(sp, i);
  }
  
  return (double) -1;
}

