/*-----------------------------------------------------------------*/
/* Module : Configuration files                                    */
/*                                                                 */
/* Description : Interface for working with configuration files    */
/*                                                                 */
/*-----------------------------------------------------------------*/

/*
    $Id: cfgfile.h,v 1.2 2003/10/31 15:36:53 juhani Exp $
*/

#ifndef CFGFILE_H
#define CFGFILE_H

#if defined(__cplusplus)
extern "C" {
#endif

/*======================== Structures =============================*/

/* open modes */
typedef enum {

    CFILE_READ,
    CFILE_CHANGE,
    CFILE_WRITE

} CfgFileMode ;

/*======================== Structures =============================*/

typedef void * HCFGFILE ;

/*======================== Functions ==============================*/

/* creation/deletion */
HCFGFILE cfOpen(char * file_name,CfgFileMode mode) ;
void cfClose(HCFGFILE cf) ;

/* working with sections */
int cfSize(HCFGFILE cf) ;
int cfSelectSection(HCFGFILE cf,char * section_name) ;
int cfCreateSection(HCFGFILE cf,char * section_name) ;

/* working with parameters */
int cfSectionSize(HCFGFILE cf) ;
int cfSelectParam(HCFGFILE cf,char * param_name) ;
int cfCreateParam(HCFGFILE cf,char * param_name) ;

/* get parameters */
char * cfGetTextValue(HCFGFILE cf) ;
int cfGetBoolValue(HCFGFILE cf) ;
int cfGetIntValue(HCFGFILE cf) ;
double cfGetDoubleValue(HCFGFILE cf) ;

/* copy parameters */
char * cfCopyTextValue(HCFGFILE cf) ;

/* set parameters */
int cfSetTextValue(HCFGFILE cf,char * value) ;
int cfSetBoolValue(HCFGFILE cf,int value) ;
int cfSetIntValue(HCFGFILE cf,int value) ;
int cfSetDoubleValue(HCFGFILE cf,double value) ;

/* reading of all parameters */
int cfSelectNextSection(HCFGFILE cf) ;
int cfSelectNextParam(HCFGFILE cf) ;
char * cfGetParam(HCFGFILE cf) ;

/*======================== Functions ==============================*/

#if defined(__cplusplus)
}
#endif

#endif /* CFGFILE_H */
