/*! 
\file 
\brief Set of models

Functionality to work with set of models

\date 18 November 2003
\author Evgeny Karpov
*/

/*
    $Id: modelset.h,v 1.2 2003/11/18 19:05:47 ekarpov Exp $
*/

#ifndef __MODELSET_H__
#define __MODELSET_H__

/*-----------------------------------------------------------------*/

#if defined(__cplusplus)
extern "C" {
#endif

/*-----------------------------------------------------------------*/

/*! Abstarct function type to destroy models */
typedef void (*SMFREE) (void * model) ;

/*-----------------------------------------------------------------*/

/*! Abstract handle to model set */
typedef void * HMS ;

/*======================== Functions ==============================*/

/* creation/deletion */
HMS msCreate(int size,SMFREE free_func) ;
void msDestroy(HMS ms) ;

/* working with set */
int msAddModel(HMS ms,void * model,int id,int flags,void * params) ;
int msRemoveModel(HMS ms,int id) ;
int msGetSize(HMS ms) ;

/* working with parameters */
int msGetModelId(HMS ms,int num) ;
int msGetModelFlags(HMS ms,int num) ;
int msSetModelFlags(HMS ms,int num,int flags) ;
void * msGetModelParams(HMS ms,int num) ;

/* getting models from set */
void * msGetModel(HMS ms,int num) ;

/* set merging */
HMS msMerge(HMS set1,HMS set2) ;

/*======================== Functions ==============================*/

#if defined(__cplusplus)
}
#endif

#endif /* __MODELSET_H__ */
