/*! 
\file smetric.h
\brief Interface to set distance computation

This module has several functions for
computing distances of sets.\n
$Id: smetric.h,v 1.5 2003/11/20 11:44:34 ekarpov Exp $
\date 2003
\author Evgeny Karpov
*/

#ifndef SMETRIC_H
#define SMETRIC_H

#include <msindex.h>
#include <fvector.h>

#include "distfunc.h"

/*-----------------------------------------------------------------*/

#if defined(__cplusplus)
extern "C" {
#endif

/*======================== Functions ==============================*/

/* Hausdorff metric */
double smHausdorff(HFSET left_set,HFSET right_set,
                   DISTFUNC dist_func, void * dfunc_params) ;

/* sum of minimum distances */
double smSumOfMin(HFSET left_set,HFSET right_set,
                  DISTFUNC dist_func, void * dfunc_params) ;

/* metric using indexes */
double smHausdorffIdx(HFSET left_set,HFSET right_set,HMSIDX indexer,
                      HMSINDEX left_idx,HMSINDEX right_idx) ;

double smSumOfMinIdx(HFSET left_set,HFSET right_set,HMSIDX indexer,
                      HMSINDEX left_idx,HMSINDEX right_idx) ;

/*======================== Functions ==============================*/

#if defined(__cplusplus)
}
#endif

#endif /* SMETRIC_H */

